from __future__ import with_statement

from Foundation import *
from AppKit import *
import objc

# Local imports from within Circuit Editor
from CE.Component import Component
from draw_extras import *

import circuitsim

class Ground(Component):
	width = 2
	height = 1
	pin_locations = [(0,0.5)]
	class_name = "Ground"
		
	def __init__(self, serialized_form = None):
		self.component = circuitsim.Ground()
		Component.__init__(self, serialized_form)

	def subdraw(self):
		with in_affine_transform(rescaler):
			NSImage.imageNamed_("Ground").drawAtPoint_fromRect_operation_fraction_(
				(-self.width/2.0*16.0,-self.height/2.0*16.0),
				NSZeroRect,
				NSCompositeSourceOver,
				1.0)
