from __future__ import with_statement

from Foundation import *
from AppKit import *
import objc

# Local imports from within Circuit Editor
from CE.Component import Component
from notifications import post_notification
from draw_extras import *

import circuitsim

class PushSwitch(Component):
	width = 2
	height = 2
	pin_locations = [(-1,-1), (1,-1)]
	class_name = "Push Switch"
	
	manipulation_zones = [((-0.8,0), (1.6,1))]
		
	def __init__(self, serialized_form = None):
		self.component = circuitsim.SimpleSwitch()
		Component.__init__(self, serialized_form)

	def subdraw(self):
	
		if self.component.state == "Closed": icon = NSImage.imageNamed_("PushSwitch2")
		else: icon = NSImage.imageNamed_("PushSwitch")
	
		with in_affine_transform(rescaler):
			icon.drawAtPoint_fromRect_operation_fraction_(
				(-self.width/2.0*16.0,-self.height/2.0*16.0),
				NSZeroRect,
				NSCompositeSourceOver,
				1.0)
	
	def start_manipulation(self, p):
		self.component.close()
		post_notification("CircuitElementManipulated", self.circuit, self)
	
	def end_manipulation(self, p):
		self.component.open()
		post_notification("CircuitElementManipulated", self.circuit, self)